local G 	= GLOBAL
local M 	= G.MarkMod

local config_options = {
	DarkThresh 			 = "darkthresh",
	WarFXSize 			 = "warfxsize",
	BlacksmithSwordPower = "blacksmithswordpower",
	ManiacChance 		 = "maniacchance",
	ManiacWarn			 = "maniacwarn",
	HeroChance			 = "herochance",
	HeroHealth			 = "herodifficulty"
}

for k,v in pairs(config_options) do
	if GetModConfigData(v) ~= nil then
		M[k] = GetModConfigData(v)
	else
		M[k] = nil
	end
end

PrefabFiles = {
	"markiplier",
	"tinyboxtim",
	"tinytimdevice",
	"warfstache",
	--"hoodedhero",
	"blacksmithsafe",
	"blacksmithplatinum",
	"blacksmithsword",
	"blacksmithnote",
	"operatingtool"
}

local TemporaryAssets = {}

local MarkimodImages = {
	{ --InventoryImages
		"warfstache",
		"tinytimdevice",
		"blacksmithsword",
		"blacksmithplatinum",
		"blacksmithsafe",
		"blacksmithnote",
		"fedora",
		"operatingtool"
	},
	{ --Minimap
		"markiplier",
		"markipliertwo",
		"markiplierthree",
		--"markiplierfour",
		"markiplierfive",
		"blacksmithsafe",
		"blacksmithnote",
		"tinyboxtim",
		"tinywarfboxtim",
		"euphoricboxtim",
		"euphoricwarfboxtim",
		"tinytimdevice",
		"warfstache",
		"fedora"
	}
}

local filetypes = {
	{"IMAGE", ".tex"},
	{"ATLAS", ".xml"},
	"images/inventoryimages/",
	"images/minimap/"
}

for e = 1,2 do
	table.insert(TemporaryAssets, Asset( filetypes[e][1], "images/selectscreen_portraits/markiplier"..filetypes[e][2] ))
	table.insert(TemporaryAssets, Asset( filetypes[e][1], "images/selectscreen_portraits/markiplier_silho"..filetypes[e][2] ))
	table.insert(TemporaryAssets, Asset( filetypes[e][1], "images/avatars/avatar_ghost_markiplier"..filetypes[e][2] ))
	table.insert(TemporaryAssets, Asset( filetypes[e][1], "images/avatars/avatar_markiplier"..filetypes[e][2] ))
	table.insert(TemporaryAssets, Asset( filetypes[e][1], "images/saveslot_portraits/markiplier"..filetypes[e][2] ))
	for f = 1,#MarkimodImages do
		for g,h in pairs(MarkimodImages[f]) do
			table.insert(TemporaryAssets, Asset( filetypes[e][1], filetypes[(f + 2)]..h..filetypes[e][2] ))
		end
	end
end

Assets = TemporaryAssets

for k,v in pairs(MarkimodImages[2]) do
	AddMinimapAtlas("images/minimap/"..v..".xml")
end

if G.FinalMarkiModCharacter == "markiplier" then G.AllMarkiModsLoaded = true end