local assets = {Asset("ANIM", "anim/papyrus.zip"), Asset("ATLAS", "images/inventoryimages/blacksmithnote.xml")}

local ChanceTable = {1,5,10,20,30,40,50,100,150,250,350,500,750,900,1000}

local function getstatus(inst)
	if TheWorld.state.isday or TheWorld.state.isdusk --[[and not GetWorld():IsCave()]] then
		return "DAY_NOREAD"
	--[[elseif GetWorld():IsCave() then
		return "CAVE_NOREAD"]]
	else
		if inst.readable == true then
			return inst.blacksmithquote
		else
			return "ALREADY_READ_TONIGHT"
		end
	end
end

local function ExaminationDetected(inst, player)
	if not TheWorld.state.isday and not TheWorld.state.isdusk --[[and not GetWorld():IsCave()]] and inst.readable == true then
		if player.prefab == "markiplier" then
			if player.MarkState ~= "Darkiplier" then
				if inst.timer <= 14 then inst.timer = inst.timer + 1 end
				inst.blacksmithquote = "BLACKSMITH_"..tostring(inst.timer)
				inst:DoTaskInTime(0.05, function() inst.readable = false end)
				if math.random(1,1000) <= ChanceTable[inst.timer] then
					inst:DoTaskInTime(2, function()
						player:SetManiac(player, true)
						inst.timer = 1
					end)
				end
			end
		end
	end
end

local function onsave(inst, data)
	data.blacksmithquote = inst.blacksmithquote
	data.timer = inst.timer
	data.readable = inst.readable
end

local function onload(inst, data)
	if data then
		inst.blacksmithquote = data.blacksmithquote or "BLACKSMITH_1"
		inst.timer = data.timer or 1
		inst.readable = data.readable or true
	end
end

local function fn(Sim)
    local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddNetwork()
    MakeInventoryPhysics(inst)
	
    inst.AnimState:SetBank("papyrus")
    inst.AnimState:SetBuild("papyrus")
    inst.AnimState:PlayAnimation("idle")
	
	inst.entity:AddMiniMapEntity()
    inst.MiniMapEntity:SetIcon("blacksmithnote.tex")
	
	inst.entity:SetPristine()
	if not TheWorld.ismastersim then
		return inst
	end
	MakeHauntableLaunch(inst)
	
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/blacksmithnote.xml"
	
	inst.blacksmithquote = "BLACKSMITH_1"
	inst.timer = 1
	inst.readable = true
	inst:ListenForEvent( "daycomplete", function()
		if inst.readable ~= true then inst.readable = true end
	end, TheWorld)
	
	inst:AddComponent("inspectable")
	inst.components.inspectable.getstatus = getstatus
	inst.components.inspectable.descriptionfn = ExaminationDetected
	
	inst.OnSave = onsave
	inst.OnLoad = onload
    return inst
end

return Prefab( "common/inventory/blacksmithnote", fn, assets) 