require "prefabutil"

local assets = {
	Asset( "SOUND", "sound/markimod.fsb" ),
	Asset("ANIM", "anim/blacksmithsafe.zip"),
	Asset("ANIM", "anim/ui_blacksmith_chest_3x4.zip"),
}

local BlacksmithWidget = {
	widget = {
		slotpos = {},
		animbank = "ui_chester_shadow_3x4",
		animbuild = "ui_blacksmith_chest_3x4",
		pos = Vector3(0, 200, 0),
		side_align_tip = 160,
	},
	type = "chest",
}

for y = 2.5, -0.5, -1 do
	for x = 0, 2 do
		table.insert(BlacksmithWidget.widget.slotpos, Vector3(75*x-75*2+75, 75*y-75*2+75,0))
	end
end

local function OnWidgetUpdate(inst)
    inst.replica.container:WidgetSetup(inst.prefab, BlacksmithWidget)
end

local function onopen(inst) 
	inst.AnimState:PlayAnimation("idleopen") 
	inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_open")
end 

local function onclose(inst)
	inst.AnimState:PlayAnimation("idleunlocked") 
	inst.SoundEmitter:PlaySound("dontstarve/wilson/chest_close")
end 

local function fn (Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddMiniMapEntity()
	inst.entity:AddSoundEmitter()
	inst.entity:AddNetwork()

	inst.MiniMapEntity:SetIcon("blacksmithsafe.tex")
	
	inst.Transform:SetScale(2,2,2)
	
	inst:AddTag("blacksmithsafe")
	
	inst.AnimState:SetBank("blacksmithsafe")
	inst.AnimState:SetBuild("blacksmithsafe")
	inst.AnimState:PlayAnimation("idleunlocked")
	
	inst._widgetupdate = net_bool(inst.GUID, "_widgetupdate", "onwidgetupdate")
	
	inst.entity:SetPristine()
	if not TheWorld.ismastersim then
		inst:ListenForEvent("onwidgetupdate", OnWidgetUpdate)
		return inst
	end
	
	inst:AddComponent("inspectable")
	
	inst:AddComponent("container")
	inst.components.container:SetNumSlots(12)
	inst.components.container.onopenfn = onopen
	inst.components.container.onclosefn = onclose
	inst.components.container:WidgetSetup(inst.prefab, BlacksmithWidget)
	inst._widgetupdate:set(true)
	
	MakeSnowCovered(inst) 
	
	return inst
end
return Prefab( "common/blacksmithsafe", fn, assets),
	   MakePlacer("common/blacksmithsafe_placer", "blacksmithsafe", "blacksmithsafe", "placer")