local assets = {
	Asset("ANIM", "anim/timstinyplushy.zip"),
	Asset("ATLAS", "images/inventoryimages/tinytimdevice.xml")
}

local prefabs = { "tinyboxtim" }

--[[local function sync(inst, tim, mark)
	inst.MyTim = tim
	inst.MyMark = mark
	tim.MyMark = mark
	tim.MyPlush = inst
	mark.Tim = tim
	mark.TimPlush = inst
	if tim.components.follower.leader == nil then tim.components.follower:SetLeader(inst) end
end]]

local function SpawnTim(inst, mark)
	if inst.MyTim == nil then
		local tim = SpawnPrefab("tinyboxtim")
		tim.Transform:SetPosition(mark:GetPosition():Get())
		if tim.components.follower.leader == nil then tim.components.follower:SetLeader(inst) end
		--inst:sync(tim, mark)
	end
end

local function fn(Sim)
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
	inst.entity:AddNetwork()
	MakeInventoryPhysics(inst)

    inst.AnimState:SetBank("timstinyplushy")
    inst.AnimState:SetBuild("timstinyplushy")
    inst.AnimState:PlayAnimation("idle", true)
	
	inst.entity:AddDynamicShadow()
	inst.DynamicShadow:SetSize( 1, 1 )
	
	inst.entity:AddMiniMapEntity()
    inst.MiniMapEntity:SetIcon("tinytimdevice.tex")
	
	inst:AddTag("tinytimdevice")
	inst:AddTag("irreplaceable")
	
	inst.entity:SetPristine()
	if not TheWorld.ismastersim then
		return inst
	end
	MakeHauntableLaunch(inst)
	
	--inst.MyMark = nil
	--inst.MyTim = nil
	inst.SpawnTim = SpawnTim
	--inst.sync = sync
	
	inst:AddComponent("leader")
	inst:AddComponent("inspectable")
	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/tinytimdevice.xml"
	
	inst:DoPeriodicTask(0.1, function()
		if not inst.components.leader.follower then
			if TheSim:FindFirstEntityWithTag("tinyboxtimnoleader") then TheSim:FindFirstEntityWithTag("tinyboxtimnoleader").components.follower:SetLeader(inst) end
		end
	end)

	return inst
end

return Prefab( "common/tinytimdevice", fn, assets) 